#include <xc.h>
#include "common.h"


extern unsigned int Flag_Timer1 ;
extern unsigned int Flag_Timer1_Counter ;
extern unsigned int Flag_Timer1_1S ;
extern unsigned int Flag_Timer1_200MS ;

void    Timer1_Initial(void)
{
    T1CON = 0x0000 ;
    TMR1 = 0 ;
    PR1 = 15014 ;                                // 2 ms interrupt interval @ FOSC=60Mhz, Prescale 1:8 
    
    T1CONbits.TCKPS = 01 ;               // Prescale = 1:8
    T1CONbits.TGATE = 0 ;               // Disable Gated Timer
    T1CONbits.TSIDL = 1 ;                // Discontinue timer when idle
    T1CONbits.TSYNC = 0 ;
    T1CONbits.TCS = 0 ;                     // Select Internal closk source ( Fosc/2) 

    IFS0bits.T1IF = 0 ;
    IEC0bits.T1IE = 1 ;                         // Enable Timer1 Interrupt 
    
   T1CONbits.TON = 1 ;                         // Start the Timer-1
}


void __attribute__ ( (interrupt, no_auto_psv) ) _T1Interrupt( void )
{
    IFS0bits.T1IF = 0 ;
    Flag_Timer1 = 1 ;
    
     Flag_Timer1_Counter += 1 ;
    
     if ((Flag_Timer1_Counter % 100) == 0 )
        Flag_Timer1_200MS = 1 ;    
    
    if (Flag_Timer1_Counter >= 500 )
    {
        LED4 = !LED4 ;      // Toggle LED4
        Flag_Timer1_1S = 1 ;
        Flag_Timer1_Counter = 0 ;
    }
    
    Nop();
    Nop();
}
